(* Un analyseur lexical pour mini-ML *)

{
open Parser

let oprateurs = [ "fix" ]
}

rule token = parse
    [' ' '\010' '\013' '\009' '\012'] +
      { token lexbuf }
  | '-'? ['0'-'9']+
      { INT(int_of_string(Lexing.lexeme lexbuf)) }
  | "," { COMMA }
  | "fun" { FUN }
  | "fst" { FST }
  | "snd" { SND }
  | "->" { ARROW }
  | "let" { LET }
  | "=" { EQUAL }
  | "in" { IN }
  | "(" { LPAREN }
  | ")" { RPAREN }
  | "{" { LBRACE }
  | "}" { RBRACE }
  | ";" { SEMI }
  | "." { DOT }
  | "@" { AT }
  | ['A'-'Z' 'a'-'z' '_'] ['A'-'Z' 'a'-'z' '0'-'9' '_'] *
      { let s = Lexing.lexeme lexbuf in
        if List.mem s oprateurs then OP s else IDENT s }
  | ['!' '$' '%' '&' '*' '+' '-' '/' ':' '<' '=' '>' '?' '@' '^' '|' '~'] +
      { OP(Lexing.lexeme lexbuf) }
  | eof { EOF }
